#!/usr/bin/perl

use warnings;
use strict;

my $fn = shift || 'data.dat';
my $DELIM = ',';
my $HEADER_TARGET = 'DV1,Var1,Var2'; #sync changes with split on line 20

open( my $fh, '<', $fn) or die( "Cannot open \"$fn\": $!\n");
my $header = <$fh>;
$header =~ s/[\r\n]+//g; # chomp any newlines and only newlines
die("The header should be: \"$HEADER_TARGET\", not \"$header\"\n") 
   unless( lc $header eq lc $HEADER_TARGET);

my %ns; # holds n's
my %means; # holds means
while( my $line = <$fh> ) { 
  $line =~ s/[\r\n]+//g; # chomp any newlines and only newlines
  $line =~ s/ +//g unless( $DELIM eq ' '); # remove spaces
  my($dv,$fac1,$fac2) = split( /$DELIM/, $line); # sync with $HEADER_TARGET line 8
  $means{"fac1=$fac1"} += $dv;
  $means{"fac2=$fac2"} += $dv;
  $means{"fac1=$fac1, fac2=$fac2"} += $dv;
  $means{"grand"} += $dv;
  $ns{"fac1=$fac1"}++;
  $ns{"fac2=$fac2"}++;
  $ns{"fac1=$fac1, fac2=$fac2"}++;
  $ns{"grand"}++;
}

printf "%8s  %8s  %s\n", 'means', 'N', 'which';
for my $val ( sort keys %means ) { 
  printf "%8.3f  %8d  %s\n", $means{$val}/$ns{$val}, $ns{$val}, $val;
}
