#!/usr/bin/perl

use warnings;
use strict;

my $fn = shift || 'data.dat';
my $DELIM = ',';
my $HEADER_TARGET = 'DV1,Var1,Var2'; #sync changes with split on line 20

open( my $fh, '<', $fn) or die( "Cannot open \"$fn\": $!\n");
my $header = <$fh>;
$header =~ s/[\r\n]+//g; # chomp any newlines and only newlines
die("The header should be: \"$HEADER_TARGET\", not \"$header\"\n") 
   unless( lc $header eq lc $HEADER_TARGET);

my %ns; # holds n's
my %means; # holds means
my %fac1_levels;
my %fac2_levels;
while( my $line = <$fh> ) { 
  $line =~ s/[\r\n]+//g; # chomp any newlines and only newlines
  $line =~ s/ +//g unless( $DELIM eq ' '); # remove spaces
  my($dv,$fac1,$fac2) = split( /$DELIM/, $line); # sync with $HEADER_TARGET line 8
  $means{"fac1=$fac1"} += $dv;
  $means{"fac2=$fac2"} += $dv;
  $means{"fac1=$fac1, fac2=$fac2"} += $dv;
  $means{"grand"} += $dv;
  $ns{"fac1=$fac1"}++;
  $ns{"fac2=$fac2"}++;
  $ns{"fac1=$fac1, fac2=$fac2"}++;
  $ns{"grand"}++;
  $fac1_levels{$fac1}++;
  $fac2_levels{$fac2}++;
}

#printf "%8s  %8s  %s\n", 'means', 'N', 'which';
#for my $val ( sort keys %means ) { 
#  printf "%8.3f  %8d  %s\n", $means{$val}/$ns{$val}, $ns{$val}, $val;
#}

# print headers
print ' ' x 12, "var 1\n";
printf "%8s", 'var2';
for my $f1 ( sort keys %fac1_levels ) { 
  printf "%8s","lev $f1";
}
printf "%8s\n","total";

# print body
for my $f2 ( sort keys %fac2_levels ) { 
  printf "%8s", "lev $f2";
  for my $f1 ( sort keys %fac1_levels ) { 
    my $cell = "fac1=$f1, fac2=$f2";
    printf "%8.3f",$means{$cell}/$ns{$cell};
  }
  printf "%8.3f\n",$means{"fac2=$f2"}/$ns{"fac2=$f2"};
}

# print last row
printf "%8s", "total";
for my $f1 ( sort keys %fac1_levels ) {
  printf "%8.3f",$means{"fac1=$f1"}/$ns{"fac1=$f1"};
}
printf "%8.3f\n",$means{'grand'}/$ns{'grand'};

